diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/utils/check-style.py ns-3.31/utils/check-style.py
--- ns-3.30.1/utils/check-style.py	2019-08-12 16:43:20.000000000 -0700
+++ ns-3.31/utils/check-style.py	2020-06-27 17:38:30.000000000 -0700
@@ -10,9 +10,17 @@
 import difflib
 import re
 
-def hg_modified_files():
-    files = os.popen ('hg st -nma')
-    return [filename.strip() for filename in files]
+def git_modified_files():
+    files = os.popen('git diff --name-only')
+    process = subprocess.Popen(["git","rev-parse","--show-toplevel"],
+                               stdout = subprocess.PIPE,
+                               stderr = subprocess.PIPE)
+    (root_dir, error) = process.communicate()
+    if isinstance(root_dir, bytes):
+        root_dir=root_dir.decode("utf-8")
+    files_changed = [item.strip() for item in files.readlines()]
+    files_changed = [item for item in files_changed if item.endswith('.h') or item.endswith('.cc')]
+    return [root_dir[: -1] + "/" + filename.strip () for filename in files_changed]
 
 def copy_file(filename):
     [tmp,pathname] = tempfile.mkstemp()
@@ -27,7 +35,6 @@
 # generate a temporary configuration file
 def uncrustify_config_file(level):
     level2 = """
-nl_collapse_empty_body=False
 nl_if_brace=Add
 nl_brace_else=Add
 nl_elseif_brace=Add
@@ -38,17 +45,20 @@
 nl_brace_while=Add
 nl_switch_brace=Add
 nl_after_case=True
-nl_namespace_brace=Remove
+nl_namespace_brace=ignore
 nl_after_brace_open=True
 nl_class_leave_one_liners=False
 nl_enum_leave_one_liners=False
 nl_func_leave_one_liners=False
 nl_if_leave_one_liners=False
 nl_class_colon=Ignore
-nl_after_access_spec=1
+nl_before_access_spec=2
+nl_after_access_spec=0
+indent_access_spec=-indent_columns
 nl_after_semicolon=True
 pos_class_colon=Lead
 pos_class_comma=Trail
+indent_constr_colon=true
 pos_bool=Lead
 nl_class_init_args=Add
 nl_template_class=Add
@@ -74,6 +84,7 @@
 #code_width=128
 #ls_for_split_full=True
 #ls_func_split_full=True
+nl_cpp_lambda_leave_one_liners=True
 """
     level1 = """
 # extra spaces here and there
@@ -101,7 +112,7 @@
 nl_enum_leave_one_liners=True
 nl_func_leave_one_liners=True
 nl_assign_leave_one_liners=True
-#nl_collapse_empty_body=False
+nl_collapse_empty_body=True
 nl_getset_leave_one_liners=True
 nl_if_leave_one_liners=True
 nl_fdef_brace=Ignore
@@ -110,15 +121,18 @@
 indent_namespace=false
 indent_columns=2
 indent_brace=2
-indent_case_brace=2
+indent_case_brace=indent_columns
 indent_class=true
 indent_class_colon=True
+indent_switch_case=indent_columns
 # alignment
 indent_align_assign=False
 align_left_shift=True
 # comment reformating disabled
 cmt_reflow_mode=1 # do not touch comments at all
 cmt_indent_multi=False # really, do not touch them
+disable_processing_cmt= " *NS_CHECK_STYLE_OFF*"
+enable_processing_cmt=  " *NS_CHECK_STYLE_ON*"
 """
     [tmp,pathname] = tempfile.mkstemp()
     dst = open(pathname, 'w')
@@ -433,7 +447,8 @@
         uncrust = subprocess.Popen(['uncrustify', '-c', cfg, '-f', source, '-o', output],
                                    stdin = subprocess.PIPE,
                                    stdout = subprocess.PIPE,
-                                   stderr = subprocess.PIPE)
+                                   stderr = subprocess.PIPE,
+                                   universal_newlines = True)
         (out, err) = uncrust.communicate('')
         if debug:
             sys.stderr.write(out)
@@ -473,7 +488,8 @@
     patch = subprocess.Popen(['patch', '-p1', '-i', final_diff, output],
                              stdin = subprocess.PIPE,
                              stdout = subprocess.PIPE,
-                             stderr = subprocess.PIPE)
+                             stderr = subprocess.PIPE,
+                             universal_newlines = True)
     (out, err) = patch.communicate('')
     if debug:
         sys.stderr.write(out)
@@ -513,16 +529,6 @@
         return False
     return True
 
-def run_as_hg_hook(ui, repo, **kwargs):
-    # hack to work around mercurial < 1.3 bug
-    from mercurial import lock, error
-    lock.LockError = error.LockError
-    # actually do the work
-    files = hg_modified_files()
-    if not indent_files(files, inplace=False):
-        return True
-    return False
-
 def run_as_main():
     parser = optparse.OptionParser()
     parser.add_option('--debug', action='store_true', dest='debug', default=False,
@@ -531,11 +537,8 @@
                       help="Level of style conformance: higher levels include all lower levels. "
                       "level=0: re-indent only. level=1: add extra spaces. level=2: insert extra newlines and "
                       "extra braces around single-line statements. level=3: remove all trailing spaces")
-    parser.add_option('--check-hg-hook', action='store_true', dest='hg_hook', default=False, 
-                      help='Get the list of files to check from mercurial\'s list of modified '
-                      'and added files and assume that the script runs as a pretxncommit mercurial hook')
-    parser.add_option('--check-hg', action='store_true', dest='hg', default=False,
-                      help="Get the list of files to check from mercurial\'s list of modified and added files")
+    parser.add_option('--check-git', action='store_true', dest='git', default=False,
+                      help="Get the list of files to check from Git\'s list of modified and added files")
     parser.add_option('-f', '--check-file', action='store', dest='file', default='',
                       help="Check a single file")
     parser.add_option('--diff', action='store_true', dest='diff', default=False,
@@ -544,33 +547,34 @@
                       help="Indent the input files in-place")
     (options,args) = parser.parse_args()
     debug = options.debug
-    if options.hg_hook:
-        files = hg_modified_files()
-        if not indent_files(files, debug=options.debug,
-                            level=options.level,
-                            inplace=False):
-            sys.exit(1)
-    elif options.hg:
-        files = hg_modified_files()
-        indent_files(files, diff=options.diff, 
-                     debug=options.debug,
-                     level=options.level,
-                     inplace=options.in_place)
+    style_is_correct = False;
+
+    if options.git:
+        files = git_modified_files()
+        style_is_correct = indent_files(files,
+                                        diff=options.diff,
+                                        debug=options.debug,
+                                        level=options.level,
+                                        inplace=options.in_place)
     elif options.file != '':
         file = options.file
         if not os.path.exists(file) or \
                 not os.path.isfile(file):
             print('file %s does not exist' % file)
             sys.exit(1)
-        indent_files([file], diff=options.diff, 
-                     debug=options.debug,
-                     level=options.level,
-                     inplace=options.in_place)
+        style_is_correct = indent_files([file],
+                                        diff=options.diff,
+                                        debug=options.debug,
+                                        level=options.level,
+                                        inplace=options.in_place)
+
+    if not style_is_correct:
+        sys.exit(1)
     sys.exit(0)
 
 if __name__ == '__main__':
-#    try:
+     try:
         run_as_main()
-#    except Exception, e:
-#        sys.stderr.write(str(e) + '\n')
-#        sys.exit(1)
+     except Exception as e:
+        sys.stderr.write(str(e) + '\n')
+        sys.exit(1)
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/utils/create-module.py ns-3.31/utils/create-module.py
--- ns-3.30.1/utils/create-module.py	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/utils/create-module.py	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,637 @@
+#! /usr/bin/env python3
+import sys
+import argparse
+import os
+import re
+import shutil
+
+from pathlib import Path
+
+WSCRIPT_TEMPLATE = '''# -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
+
+# def options(opt):
+#     pass
+
+# def configure(conf):
+#     conf.check_nonfatal(header_name='stdint.h', define_name='HAVE_STDINT_H')
+
+def build(bld):
+    module = bld.create_ns3_module({MODULE!r}, ['core'])
+    module.source = [
+        'model/{MODULE}.cc',
+        'helper/{MODULE}-helper.cc',
+        ]
+
+    module_test = bld.create_ns3_module_test_library('{MODULE}')
+    module_test.source = [
+        'test/{MODULE}-test-suite.cc',
+        ]
+    # Tests encapsulating example programs should be listed here
+    if (bld.env['ENABLE_EXAMPLES']):
+        module_test.source.extend([
+        #    'test/{MODULE}-examples-test-suite.cc',
+             ])
+
+    headers = bld(features='ns3header')
+    headers.module = {MODULE!r}
+    headers.source = [
+        'model/{MODULE}.h',
+        'helper/{MODULE}-helper.h',
+        ]
+
+    if bld.env.ENABLE_EXAMPLES:
+        bld.recurse('examples')
+
+    # bld.ns3_python_bindings()
+
+'''
+
+
+
+MODEL_CC_TEMPLATE = '''/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+
+#include "{MODULE}.h"
+
+namespace ns3 {{
+
+/* ... */
+
+
+}}
+
+'''
+
+
+
+MODEL_H_TEMPLATE = '''/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+#ifndef {INCLUDE_GUARD}
+#define {INCLUDE_GUARD}
+
+namespace ns3 {{
+
+/* ... */
+
+}}
+
+#endif /* {INCLUDE_GUARD} */
+
+'''
+
+
+
+HELPER_CC_TEMPLATE = '''/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+
+#include "{MODULE}-helper.h"
+
+namespace ns3 {{
+
+/* ... */
+
+
+}}
+
+'''
+
+
+
+HELPER_H_TEMPLATE = '''/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+#ifndef {INCLUDE_GUARD}
+#define {INCLUDE_GUARD}
+
+#include "ns3/{MODULE}.h"
+
+namespace ns3 {{
+
+/* ... */
+
+}}
+
+#endif /* {INCLUDE_GUARD} */
+
+'''
+
+
+EXAMPLES_WSCRIPT_TEMPLATE = '''# -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
+
+def build(bld):
+    obj = bld.create_ns3_program('{MODULE}-example', [{MODULE!r}])
+    obj.source = '{MODULE}-example.cc'
+
+'''
+
+EXAMPLE_CC_TEMPLATE = '''/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+
+#include "ns3/core-module.h"
+#include "ns3/{MODULE}-helper.h"
+
+using namespace ns3;
+
+
+int 
+main (int argc, char *argv[])
+{{
+  bool verbose = true;
+
+  CommandLine cmd (__FILE__);
+  cmd.AddValue ("verbose", "Tell application to log if true", verbose);
+
+  cmd.Parse (argc,argv);
+
+  /* ... */
+
+  Simulator::Run ();
+  Simulator::Destroy ();
+  return 0;
+}}
+
+
+'''
+
+
+TEST_CC_TEMPLATE = '''/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+
+// Include a header file from your module to test.
+#include "ns3/{MODULE}.h"
+
+// An essential include is test.h
+#include "ns3/test.h"
+
+// Do not put your test classes in namespace ns3.  You may find it useful
+// to use the using directive to access the ns3 namespace directly
+using namespace ns3;
+
+// This is an example TestCase.
+class {CAPITALIZED}TestCase1 : public TestCase
+{{
+public:
+  {CAPITALIZED}TestCase1 ();
+  virtual ~{CAPITALIZED}TestCase1 ();
+
+private:
+  virtual void DoRun (void);
+}};
+
+// Add some help text to this case to describe what it is intended to test
+{CAPITALIZED}TestCase1::{CAPITALIZED}TestCase1 ()
+  : TestCase ("{CAPITALIZED} test case (does nothing)")
+{{
+}}
+
+// This destructor does nothing but we include it as a reminder that
+// the test case should clean up after itself
+{CAPITALIZED}TestCase1::~{CAPITALIZED}TestCase1 ()
+{{
+}}
+
+//
+// This method is the pure virtual method from class TestCase that every
+// TestCase must implement
+//
+void
+{CAPITALIZED}TestCase1::DoRun (void)
+{{
+  // A wide variety of test macros are available in src/core/test.h
+  NS_TEST_ASSERT_MSG_EQ (true, true, "true doesn\'t equal true for some reason");
+  // Use this one for floating point comparisons
+  NS_TEST_ASSERT_MSG_EQ_TOL (0.01, 0.01, 0.001, "Numbers are not equal within tolerance");
+}}
+
+// The TestSuite class names the TestSuite, identifies what type of TestSuite,
+// and enables the TestCases to be run.  Typically, only the constructor for
+// this class must be defined
+//
+class {CAPITALIZED}TestSuite : public TestSuite
+{{
+public:
+  {CAPITALIZED}TestSuite ();
+}};
+
+{CAPITALIZED}TestSuite::{CAPITALIZED}TestSuite ()
+  : TestSuite ("{MODULE}", UNIT)
+{{
+  // TestDuration for TestCase can be QUICK, EXTENSIVE or TAKES_FOREVER
+  AddTestCase (new {CAPITALIZED}TestCase1, TestCase::QUICK);
+}}
+
+// Do not forget to allocate an instance of this TestSuite
+static {CAPITALIZED}TestSuite s{COMPOUND}TestSuite;
+
+'''
+
+
+DOC_RST_TEMPLATE = '''Example Module Documentation
+----------------------------
+
+.. include:: replace.txt
+.. highlight:: cpp
+
+.. heading hierarchy:
+   ------------- Chapter
+   ************* Section (#.#)
+   ============= Subsection (#.#.#)
+   ############# Paragraph (no number)
+
+This is a suggested outline for adding new module documentation to |ns3|.
+See ``src/click/doc/click.rst`` for an example.
+
+The introductory paragraph is for describing what this code is trying to
+model.
+
+For consistency (italicized formatting), please use |ns3| to refer to
+ns-3 in the documentation (and likewise, |ns2| for ns-2).  These macros
+are defined in the file ``replace.txt``.
+
+Model Description
+*****************
+
+The source code for the new module lives in the directory ``{MODULE_DIR}``.
+
+Add here a basic description of what is being modeled.
+
+Design
+======
+
+Briefly describe the software design of the model and how it fits into 
+the existing ns-3 architecture. 
+
+Scope and Limitations
+=====================
+
+What can the model do?  What can it not do?  Please use this section to
+describe the scope and limitations of the model.
+
+References
+==========
+
+Add academic citations here, such as if you published a paper on this
+model, or if readers should read a particular specification or other work.
+
+Usage
+*****
+
+This section is principally concerned with the usage of your model, using
+the public API.  Focus first on most common usage patterns, then go
+into more advanced topics.
+
+Building New Module
+===================
+
+Include this subsection only if there are special build instructions or
+platform limitations.
+
+Helpers
+=======
+
+What helper API will users typically use?  Describe it here.
+
+Attributes
+==========
+
+What classes hold attributes, and what are the key ones worth mentioning?
+
+Output
+======
+
+What kind of data does the model generate?  What are the key trace
+sources?   What kind of logging output can be enabled?
+
+Advanced Usage
+==============
+
+Go into further details (such as using the API outside of the helpers)
+in additional sections, as needed.
+
+Examples
+========
+
+What examples using this new code are available?  Describe them here.
+
+Troubleshooting
+===============
+
+Add any tips for avoiding pitfalls, etc.
+
+Validation
+**********
+
+Describe how the model has been tested/validated.  What tests run in the
+test suite?  How much API and code is covered by the tests?  Again, 
+references to outside published work may help here.
+'''
+
+def create_file(path, template, **kwargs):
+    artifact_path = Path(path)
+
+    #open file for (w)rite and in (t)ext mode
+    with artifact_path.open("wt") as f:
+        f.write(template.format(**kwargs))
+
+def make_wscript(moduledir, modname):
+    path = Path(moduledir, 'wscript')
+    create_file(path, WSCRIPT_TEMPLATE, MODULE=modname)
+
+    return True 
+
+def make_model(moduledir, modname):
+    modelpath = Path(moduledir, "model")
+    modelpath.mkdir(parents=True)
+
+    srcfile_path = modelpath.joinpath(modname).with_suffix('.cc')
+    create_file(srcfile_path, MODEL_CC_TEMPLATE, MODULE=modname)
+
+    hfile_path = modelpath.joinpath(modname).with_suffix('.h')
+    guard = "{}_H".format(modname.replace('-', '_').upper())
+    create_file(hfile_path, MODEL_H_TEMPLATE, 
+                MODULE=modname, 
+                INCLUDE_GUARD=guard)
+
+    return True 
+
+
+def make_test(moduledir, modname):
+    testpath = Path(moduledir, "test")
+    testpath.mkdir(parents=True)
+
+    file_path = testpath.joinpath(modname+'-test-suite').with_suffix('.cc')
+    name_parts = modname.split('-')
+    create_file(file_path, TEST_CC_TEMPLATE, MODULE=modname,
+                CAPITALIZED=''.join([word.capitalize() for word in name_parts]),
+                COMPOUND=''.join([word.capitalize() if index > 0 else word for index, word in enumerate(name_parts)]))
+
+    return True 
+
+
+def make_helper(moduledir, modname):
+    helperpath = Path(moduledir, "helper")
+    helperpath.mkdir(parents=True)
+
+    srcfile_path = helperpath.joinpath(modname+'-helper').with_suffix('.cc')
+    create_file(srcfile_path, HELPER_CC_TEMPLATE, MODULE=modname)
+
+    h_file_path = helperpath.joinpath(modname+'-helper').with_suffix('.h')
+    guard = "{}_HELPER_H".format(modname.replace('-', '_').upper())
+    create_file(h_file_path, HELPER_H_TEMPLATE, MODULE=modname, INCLUDE_GUARD=guard)
+
+    return True 
+
+
+def make_examples(moduledir, modname):
+    examplespath = Path(moduledir, "examples")
+    examplespath.mkdir(parents=True)
+
+    wscriptpath = Path(examplespath, 'wscript')
+    create_file(wscriptpath, EXAMPLES_WSCRIPT_TEMPLATE, MODULE=modname)
+
+    examplesfile_path = examplespath.joinpath(modname+'-example').with_suffix('.cc')
+    create_file(examplesfile_path, EXAMPLE_CC_TEMPLATE, MODULE=modname)
+
+    return True 
+
+
+def make_doc(moduledir, modname):
+    docpath = Path(moduledir, "doc")
+    docpath.mkdir(parents=True)
+
+    #the module_dir template parameter must be a relative path
+    #instead of an absolute path
+    mod_relpath = os.path.relpath(str(moduledir))
+
+    file_name = '{}.rst'.format(modname)
+    file_path = Path(docpath, file_name)
+    create_file(file_path, DOC_RST_TEMPLATE, MODULE=modname,
+                MODULE_DIR=mod_relpath)
+
+    return True 
+
+def make_module(modpath, modname):
+    modulepath = Path(modpath, modname)
+
+    if modulepath.exists():
+        print("Module {!r} already exists".format(modname), file=sys.stderr)
+        return False
+
+    print("Creating module {}".format(modulepath))
+
+    functions = (make_wscript, make_model, make_test, 
+                 make_helper, make_examples, make_doc)
+
+    try:
+        modulepath.mkdir(parents=True)
+
+        success = all(func(modulepath, modname) for func in functions)
+
+        if not success:
+            raise ValueError("Generating module artifacts failed")
+
+    except Exception as e:
+        if modulepath.exists():
+            shutil.rmtree(modulepath)
+
+        print("Creating module {!r} failed: {}".format(modname, str(e)), file=sys.stderr)
+
+        return False
+
+    return True
+
+def create_argument_parser():
+    description = """Generate scaffolding for ns-3 modules
+
+Generates the directory structure and skeleton files required for an ns-3
+module.  All of the generated files are valid C/C++ and will compile successfully
+out of the box.  waf configure must be run after creating new modules in order
+to integrate them into the ns-3 build system.
+
+The following directory structure is generated under the contrib directory:
+<modname>
+ |-- wscript
+ |-- doc
+     |-- <modname>.rst
+ |-- examples
+     |-- <modname>-example.cc
+     |-- wscript
+ |-- helper
+     |-- <modname>-helper.cc
+     |-- <modname>-helper.h
+ |-- model
+     |-- <modname>.cc
+     |-- <modname>.h
+ |-- test
+     |-- <modname>-test-suite.cc
+
+
+<modname> is the name of the module and is restricted to the following
+character groups: letters, numbers, -, _ 
+The script validates the module name and skips modules that have characters
+outside of the above groups.  One exception to the naming rule is that src/ 
+or contrib/ may be added to the front of the module name to indicate where the 
+module scaffold should be created.  If the module name starts with src/, then 
+the module is placed in the src directory.  If the module name starts with 
+contrib/, then the module is placed in the contrib directory.  If the module 
+name does not start with src/ or contrib/, then it defaults to contrib/.
+See the examples section for use cases.
+
+
+In some situations it can be useful to group multiple related modules under one
+directory.  Use the --project option to specify a common parent directory where
+the modules should be generated.  The value passed to --project is treated
+as a relative path.  The path components have the same naming requirements as 
+the module name: letters, numbers, -, _
+The project directory is placed under the contrib directory and any parts of the
+path that do not exist will be created.  Creating projects in the src directory 
+is not supported.  Module names that start with src/ are not allowed when
+--project is used.  Module names that start with contrib/ are treated the same
+as module names that don't start with contrib/ and are generated under the
+project directory.
+"""
+
+    epilog = """Examples:
+  %(prog)s module1
+  %(prog)s contrib/module1
+
+      Creates a new module named module1 under the contrib directory
+
+  %(prog)s src/module1
+
+      Creates a new module named module1 under the src directory
+
+  %(prog)s src/module1 contrib/module2, module3
+
+      Creates three modules, one under the src directory and two under the
+      contrib directory
+
+  %(prog)s --project myproject module1 module2
+
+      Creates two modules under contrib/myproject
+
+  %(prog)s --project myproject/sub_project module1 module2
+
+      Creates two modules under contrib/myproject/sub_project
+
+"""
+
+    formatter = argparse.RawDescriptionHelpFormatter
+
+    parser = argparse.ArgumentParser(description=description,
+                                     epilog=epilog,
+                                     formatter_class=formatter)
+
+    parser.add_argument('--project', default='',
+                        help=("Specify a relative path under the contrib directory "
+                            "where the new modules will be generated. The path "
+                            "will be created if it does not exist."))
+
+    parser.add_argument('modnames', nargs='+',
+                        help=("One or more modules to generate.  Module names "
+                            "are limited to the following: letters, numbers, -, "
+                            "_. Modules are generated under the contrib directory "
+                            "except when the module name starts with src/. Modules "
+                            "that start with src/ are generated under the src "
+                            "directory."))
+
+    return parser
+
+def main(argv):
+    parser = create_argument_parser() 
+
+    args = parser.parse_args(argv[1:])
+
+    project = args.project
+    modnames = args.modnames
+
+    base_path = Path.cwd() 
+
+    src_path = base_path.joinpath('src')
+    contrib_path = base_path.joinpath('contrib')
+
+    for p in (src_path, contrib_path):
+        if not p.is_dir():
+            parser.error("Cannot find the directory '{}'.\nPlease run this "
+                        "script from the top level of the ns3 directory".format(
+                            p))
+
+    #
+    # Error check the arguments
+    #
+
+    # Alphanumeric and '-' only
+    allowedRE = re.compile('^(\w|-)+$')
+
+    project_path = None 
+
+    if project:
+        #project may be a path in the form a/b/c
+        #remove any leading or trailing path separators
+        project_path = Path(project)
+
+        if project_path.is_absolute():
+            #remove leading separator
+            project_path = project_path.relative_to(os.sep)
+
+        if not all(allowedRE.match(part) for part in project_path.parts): 
+            parser.error('Project path may only contain the characters [a-zA-Z0-9_-].')
+    #
+    # Create each module, if it doesn't exist
+    #
+    modules = []
+    for name in modnames:
+        if name:
+            #remove any leading or trailing directory separators 
+            name = name.strip(os.sep)
+
+        if not name:
+            #skip empty modules
+            continue
+
+        name_path = Path(name)
+
+        if len(name_path.parts) > 2:
+            print("Skipping {}: module name can not be a path".format(name))
+            continue
+
+        #default target directory is contrib
+        modpath = contrib_path 
+
+        if name_path.parts[0] == 'src':
+            if project:
+                parser.error("{}: Cannot specify src/ in a module name when --project option is used".format(name))
+
+            modpath = src_path
+
+            #create a new path without the src part
+            name_path = name_path.relative_to('src') 
+
+        elif name_path.parts[0] == 'contrib':
+            modpath = contrib_path
+
+            #create a new path without the contrib part
+            name_path = name_path.relative_to('contrib') 
+
+        if project_path:
+            #if a project path was specified, that overrides other paths
+            #project paths are always relative to the contrib path
+            modpath = contrib_path.joinpath(project_path)
+
+        modname = name_path.parts[0]
+
+        if not allowedRE.match(modname):
+            print("Skipping {}: module name may only contain the characters [a-zA-Z0-9_-]".format(modname))
+            continue
+
+        modules.append((modpath, modname))
+        
+    if all(make_module(*module) for module in modules):
+        print()
+        print("Successfully created new modules")
+        print("Run './waf configure' to include them in the build")
+        
+    return 0
+
+if __name__ == '__main__':
+    return_value = 0
+    try:
+        return_value = main(sys.argv)
+    except Exception as e:
+        print("Exception: '{}'".format(e), file=sys.stderr)
+        return_value = 1 
+
+    sys.exit(return_value)
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/utils/print-introspected-doxygen.cc ns-3.31/utils/print-introspected-doxygen.cc
--- ns-3.30.1/utils/print-introspected-doxygen.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/utils/print-introspected-doxygen.cc	2020-06-27 17:38:30.000000000 -0700
@@ -25,6 +25,7 @@
  */
 
 #include <iostream>
+#include <iomanip>
 #include <algorithm>
 #include <map>
 #include <climits>    // CHAR_BIT
@@ -47,6 +48,10 @@
 
 namespace
 {
+  /**
+   * Markup tokens.
+   * @{
+   */
   std::string anchor;              ///< hyperlink anchor
   std::string argument;            ///< function argument
   std::string boldStart;           ///< start of bold span
@@ -68,6 +73,10 @@
   std::string functionStop;        ///< end of a method/function
   std::string headingStart;        ///< start of section heading (h3)
   std::string headingStop;         ///< end of section heading (h3)
+  // Linking:  [The link text displayed](\ref TheTarget) 
+  std::string hrefStart;           ///< start of a link
+  std::string hrefMid;             ///< middle part of a link
+  std::string hrefStop;            ///< end of a link
   std::string indentHtmlOnly;      ///< small indent
   std::string listLineStart;       ///< start unordered list item
   std::string listLineStop;        ///< end unordered list item
@@ -76,6 +85,7 @@
   std::string note;                ///< start a note section
   std::string page;                ///< start a separate page
   std::string reference;           ///< reference tag
+  std::string referenceNo;         ///< block automatic references
   std::string returns;             ///< the return value
   std::string sectionStart;        ///< start of a section or group
   std::string seeAlso;             ///< Reference to other docs
@@ -84,6 +94,7 @@
   std::string templArgExplicit;    ///< template argument required
   std::string templateArgument;    ///< template argument
   std::string variable;            ///< variable or class member
+  /** @} */
 
 }  // unnamed namespace
 
@@ -120,6 +131,10 @@
       functionStop                 = "\n\n";
       headingStart                 = "";
       headingStop                  = "";
+      // Linking:  The link text displayed (see TheTarget) 
+      hrefStart                    = "";
+      hrefMid                      = "(see ";
+      hrefStop                     = ")";
       indentHtmlOnly               = "";
       listLineStart                = "    * ";
       listLineStop                 = "";
@@ -128,6 +143,7 @@
       note                         = "Note: ";
       page                         = "Page ";
       reference                    = " ";
+      referenceNo                  = " ";
       returns                      = "  Returns: ";
       sectionStart                 = "Section ";
       seeAlso                      = "  See: ";
@@ -160,6 +176,10 @@
       functionStop                 = "";
       headingStart                 = "<h3>";
       headingStop                  = "</h3>";
+      // Linking:  [The link text displayed](\ref TheTarget) 
+      hrefStart                    = "[";
+      hrefMid                      = "](\\ref ";
+      hrefStop                     = ")";
       indentHtmlOnly               = "  ";
       listLineStart                = "<li>";
       listLineStop                 = "</li>";
@@ -168,6 +188,7 @@
       note                         = "\\note ";
       page                         = "\\page ";
       reference                    = " \\ref ";
+      referenceNo                  = " %";
       returns                      = "\\returns ";
       sectionStart                 = "\\ingroup ";
       seeAlso                      = "\\see ";
